'****************************************************************************
'Total Control Systems                                         QuickBasic 4.5
'****************************************************************************
'
'  Program     : ONSCREEN.BAS
'  Written by  : Tim Beck
'  Written On  : 10-01-90
'  Function    : ONSCREEN SUBROUTINE
'
'****************************************************************************
'  This program and those associated with it were written for use with Quick-
'  Windows Advanced (Version 1.5+).  Possesion of this program entitles you
'  to certain priviliges.  They are:
'
'     1. You may compile, use, or modify this program in any way you choose
'        provided you do not sell or give away the source code to this prog-
'        ram or any of it's companions to anyone for any reason.  You may,
'        however, sell the resulting executable program as you see fit.
'
'     2. You may modify, enhance or change these programs as you see fit. I
'        as that you keep a copy of the original code and that you notify
'        me of any improvements you make.  I like to think that the code is
'        bug free and cannot be improved upon, but I'm sure someone will
'        find a way to make it better.  If it's you, I'm looking forward to
'        seeing your changes.  I can be reached at:
'
'              Tim Beck                      Tim Beck (C/O Debbie Beck)
'              19419 Franz Road              8030 Fairchild Avenue
'              Houston, Texas  77084         Canoga Park, California 91306
'              (713) 639-3079                (818) 998-0588
'
'     3. This code has been tested and re-tested in a variety of applications
'        and although I have not found any bugs, doesn't mean none exist. So,
'        this program along with it's companions comes with NO WARRANTY,
'        either expressed or implied.  I'm sorry if there are problems, but
'        I can't be responsible for your work.  I've tried to provide a safe
'        and efficient programming enviroment and I hope you find it helpful
'        for you.  I do, however, need to cover my butt!
'
'  I have enjoyed creating this library of programs and have found them to be
'  a great time saver.  I hope you agree.
'
'                                                            Tim Beck //
'
'****************************************************************************
   DECLARE SUB ONSCREEN (R%, C%, msg$, csr%, attr%)

   '-----------------------------------------------------------------------
   '  Prints a Message at a specific Row and Column
   '  Clears the screen to Column 80
   '
   '  R%, C%   = Beginning Row and Column of Message
   '  msg$     = Message to Print
   '  csr%     = Cursor ON or OFF (1, 0)
   '  attr%    = Color Attribute (Fore% + (Back% * 16)) 0 = Screen


   REM $INCLUDE: 'STDCOM.INC'

   TIMER OFF    'Enables Event Trapping

'  ON ERROR GOTO ErrorTrap

ErrorTrap:

'  RESUME

SUB ONSCREEN (R%, C%, msg$, csr%, attr%) STATIC

   IF R% <= 0 OR R% > 25 THEN
      R% = CSRLIN
   END IF

   IF C% <= 0 OR C% > 80 THEN
      C% = POS(X)
   END IF

   IF attr% = 0 THEN
      attr% = S.attr%
   END IF
  
   CALL PRINTA(C%, R%, attr%, SPACE$(80 - C% + 1))
   CALL PRINTA(C%, R%, attr%, msg$)

   IF csr% THEN
      LOCATE R%, C% + LEN(msg$), 1
   END IF

END SUB

